/* Struct2: structs as classes, ownership of pointers */
#include <cstring> // For strcpy

struct treenode_t {
  char* info;
  treenode_t* left;
  treenode_t* right;

  treenode_t() {
    info = 0;
    left = 0;
    right = 0;
  }

  ~treenode_t() {
    /* Incomplete! */
    delete info;
    delete left;
    delete right;
  }
};

int main() {
  treenode_t* root = new treenode_t();
  /* Don't do this:
     root->info = "hello, world\n";
  */
  /* Instead, do this: */
  root->info = new char[14]; // surprise: not 13 (include null char)
  strcpy(root->info, "hello, world\n");

  delete root;               // ...or this will go bang
  return 0;
}
