/* Struct3: forward declarations */
#include <cstring> // For strcpy

/* Need forward declaration here... */
struct tree_t;

struct treenode_t {
  char* info;
  treenode_t* left;
  treenode_t* right;
  tree_t* my_tree;   /* ...to avoid error here */
};

/* Can't declare tree at top of file, even with forward declaration,
   because the compiler doesn't know how to call the constructor or
   how to access members.  It's a one-pass compiler! */
struct tree_t {
  treenode_t* root;
 
  tree_t() { root = new treenode_t(); }
  ~tree_t() { delete root; }
  char* get_root_info() { return root->info; }
};

int main() {
  tree_t* t = new tree_t();
  delete t;
  return 0;
}
